
#include <WS2812Serial.h>

#define NUM_LEDS 12
#define DATA_PIN 1 // To use level-converted pin 17 on the back end of Teensy LC, connect a 1Kohm resistor from pin 1 to pin 17.

byte drawingMemory[NUM_LEDS*3];         //  3 bytes per LED
DMAMEM byte displayMemory[NUM_LEDS*12]; // 12 bytes per LED

WS2812Serial leds(NUM_LEDS, displayMemory, drawingMemory, DATA_PIN, WS2812_RGB);

#include <MIDI.h>

MIDI_CREATE_INSTANCE(HardwareSerial, Serial3, MIDI);  // WS2812serial needs Serial1 on Teensy LC.

#define DMX_fixtures_curve 0 // Do DMX fixtures apply a curve?
#define color_change_threshold 25 // brightness threshold to trigger new light
#define color_change_count 0 // number of hits until new light
#define change_only_at_zero 0 // only change when light is off?
#define velocity_sensitive_brightness 0 // brightness varies with velocity?
#define velocity_sensitive_sustain 1 // brightness varies with velocity?

#define color_period_BS 14 // bitshift division to calculate time in milliseconds to complete color cycle. 14 -> 16384mS  
#define color_period_minus_1 16383 // number of binary 1's must equal color_period_BS
#define fadeoff_color_change_BS 2 // 0: 22.5 degrees, 1: 45 degrees, 2: 90 degrees, 3: 180 degrees

byte change[12] = {0,0,0,0,0,0,0,0,0,0,0,0};
byte counter[12] = {0,0,0,0,0,0,0,0,0,0,0,0};
byte current_light_number0thru11[12] = {0, 1, 2, 3, 4, 5, 6, 7,8,9,10,11};

unsigned long global_hue_ref = 0;

byte current_brightness_index[12][12]; 
byte start_brightness_index[12][12]; 
long current_millis = 0;
long start_millis[12][12];
long end_millis[12][12];

unsigned long indicator_LED_start_millis;
unsigned long indicator_LED_end_millis;

const PROGMEM uint16_t hue_offset[12] =
{0, 341, 683, 1024, 1365, 1707, 2048, 2389, 2731, 3072, 3413, 3754};

const PROGMEM uint16_t sustain[12] =
{1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,1024, 1024, 1024, 1024};

const PROGMEM uint8_t bitshift[12] =
{10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10};

const PROGMEM uint8_t curve[256] = {
0	,
1	,
1	,
1	,
1	,
1	,
1	,
1	,
1	,
1	,
1	,
2	,
2	,
2	,
2	,
2	,
3	,
3	,
3	,
3	,
3	,
4	,
4	,
4	,
4	,
5	,
5	,
5	,
6	,
6	,
6	,
6	,
7	,
7	,
7	,
8	,
8	,
9	,
9	,
9	,
10	,
10	,
10	,
11	,
11	,
12	,
12	,
12	,
13	,
13	,
14	,
14	,
15	,
15	,
16	,
16	,
17	,
17	,
18	,
18	,
19	,
19	,
20	,
20	,
21	,
21	,
22	,
23	,
23	,
24	,
24	,
25	,
25	,
26	,
27	,
27	,
28	,
29	,
29	,
30	,
31	,
31	,
32	,
33	,
33	,
34	,
35	,
35	,
36	,
37	,
38	,
38	,
39	,
40	,
41	,
41	,
42	,
43	,
44	,
44	,
45	,
46	,
47	,
48	,
49	,
49	,
50	,
51	,
52	,
53	,
54	,
55	,
55	,
56	,
57	,
58	,
59	,
60	,
61	,
62	,
63	,
64	,
65	,
66	,
67	,
68	,
69	,
70	,
71	,
72	,
73	,
74	,
75	,
76	,
77	,
78	,
79	,
80	,
81	,
82	,
83	,
84	,
85	,
86	,
88	,
89	,
90	,
91	,
92	,
93	,
94	,
96	,
97	,
98	,
99	,
100	,
101	,
103	,
104	,
105	,
106	,
108	,
109	,
110	,
111	,
113	,
114	,
115	,
116	,
118	,
119	,
120	,
122	,
123	,
124	,
126	,
127	,
128	,
130	,
131	,
132	,
134	,
135	,
136	,
138	,
139	,
141	,
142	,
144	,
145	,
146	,
148	,
149	,
151	,
152	,
154	,
155	,
157	,
158	,
160	,
161	,
163	,
164	,
166	,
167	,
169	,
170	,
172	,
173	,
175	,
177	,
178	,
180	,
181	,
183	,
185	,
186	,
188	,
190	,
191	,
193	,
194	,
196	,
198	,
199	,
201	,
203	,
205	,
206	,
208	,
210	,
211	,
213	,
215	,
217	,
218	,
220	,
222	,
224	,
226	,
227	,
229	,
231	,
233	,
235	,
236	,
238	,
240	,
242	,
244	,
246	,
247	,
249	,
251	,
253	,
255};


